diff -r ab1558b934ff configure
--- a/configure	Sun Aug 30 22:05:05 2020 +0200
+++ b/configure	Sun Aug 30 22:38:03 2020 +0200
@@ -11333,7 +11333,7 @@
 fi
 
 
-for ac_func in cbrt closedir dup2 eaccess fmod fpathconf frexp ftime getaddrinfo gethostname getnameinfo getpagesize gettimeofday getcwd getwd logb lrand48 matherr mkdir mktime perror poll random rename res_init rint rmdir select setitimer setpgid setlocale setsid sigblock sighold sigprocmask snprintf stpcpy strerror tzset ulimit usleep waitpid vsnprintf fsync ftruncate umask
+for ac_func in cbrt closedir dup2 eaccess fmod fpathconf frexp ftime getaddrinfo gethostname getnameinfo getpagesize gettimeofday getcwd getwd logb lrand48 matherr mkdir mktime perror poll random rename res_init rint rmdir select setitimer setpgid setlocale setsid sigblock sighold sigprocmask snprintf stpcpy strerror strsignal tzset ulimit usleep waitpid vsnprintf fsync ftruncate umask
 do
 echo $ac_n "checking for $ac_func""... $ac_c" 1>&6
 echo "configure:11340: checking for $ac_func" >&5
diff -r ab1558b934ff configure.in
--- a/configure.in	Sun Aug 30 22:05:05 2020 +0200
+++ b/configure.in	Sun Aug 30 22:38:03 2020 +0200
@@ -4012,7 +4012,7 @@
 dnl Check for POSIX functions.
 dnl ----------------------------------------------------------------
 
-AC_CHECK_FUNCS(cbrt closedir dup2 eaccess fmod fpathconf frexp ftime getaddrinfo gethostname getnameinfo getpagesize gettimeofday getcwd getwd logb lrand48 matherr mkdir mktime perror poll random rename res_init rint rmdir select setitimer setpgid setlocale setsid sigblock sighold sigprocmask snprintf stpcpy strerror tzset ulimit usleep waitpid vsnprintf fsync ftruncate umask)
+AC_CHECK_FUNCS(cbrt closedir dup2 eaccess fmod fpathconf frexp ftime getaddrinfo gethostname getnameinfo getpagesize gettimeofday getcwd getwd logb lrand48 matherr mkdir mktime perror poll random rename res_init rint rmdir select setitimer setpgid setlocale setsid sigblock sighold sigprocmask snprintf stpcpy strerror strsignal tzset ulimit usleep waitpid vsnprintf fsync ftruncate umask)
 
 dnl getaddrinfo() is borked under hpux11
 if test "$ac_cv_func_getaddrinfo" != "no" ; then
diff -r ab1558b934ff src/config.h.in
--- a/src/config.h.in	Sun Aug 30 22:05:05 2020 +0200
+++ b/src/config.h.in	Sun Aug 30 22:38:03 2020 +0200
@@ -346,6 +346,7 @@
 #undef HAVE_SNPRINTF
 #undef HAVE_STPCPY
 #undef HAVE_STRERROR
+#undef HAVE_STRSIGNAL
 #undef HAVE_TZSET
 #undef HAVE_ULIMIT
 #undef HAVE_USLEEP
diff -r ab1558b934ff src/process.c
--- a/src/process.c	Sun Aug 30 22:05:05 2020 +0200
+++ b/src/process.c	Sun Aug 30 22:38:03 2020 +0200
@@ -1311,7 +1311,11 @@
 signal_name (int signum)
 {
   if (signum >= 0 && signum < NSIG)
+#ifdef HAVE_STRSIGNAL
+    return strsignal (signum);
+#else
     return (const char *) sys_siglist[signum];
+#endif
 
   return (const char *) GETTEXT ("unknown signal");
 }
diff -r ab1558b934ff src/s/linux.h
--- a/src/s/linux.h	Sun Aug 30 22:05:05 2020 +0200
+++ b/src/s/linux.h	Sun Aug 30 22:38:03 2020 +0200
@@ -107,7 +107,6 @@
 
 #define NO_SIOCTL_H           /* don't have sioctl.h */
 
-#define HAVE_SYS_SIGLIST
 #define HAVE_WAIT_HEADER
 
 #define POSIX                 /* affects getpagesize.h and systty.h */
diff -r ab1558b934ff src/sysdep.c
--- a/src/sysdep.c	Sun Aug 30 22:05:05 2020 +0200
+++ b/src/sysdep.c	Sun Aug 30 22:38:03 2020 +0200
@@ -3526,7 +3526,7 @@
 /*               Strings corresponding to defined signals               */
 /************************************************************************/
 
-#if !defined (SYS_SIGLIST_DECLARED) && !defined (HAVE_SYS_SIGLIST)
+#if !defined(HAVE_STRSIGNAL) && !defined (SYS_SIGLIST_DECLARED) && !defined (HAVE_SYS_SIGLIST)
 
 #if defined(WIN32_NATIVE) || defined(CYGWIN)
 const char *sys_siglist[] =
diff -r ab1558b934ff src/syssignal.h
--- a/src/syssignal.h	Sun Aug 30 22:05:05 2020 +0200
+++ b/src/syssignal.h	Sun Aug 30 22:38:03 2020 +0200
@@ -223,10 +223,8 @@
 # define NSIG (SIGUSR2+1) /* guess how many elements are in sys_siglist... */
 #endif
 
-/* SYS_SIGLIST_DECLARED is determined by configure.  On Linux, it seems,
-   configure incorrectly fails to find it, so s/linux.h defines
-   HAVE_SYS_SIGLIST. */
-#if !defined (SYS_SIGLIST_DECLARED) && !defined (HAVE_SYS_SIGLIST)
+/* Systems that have sys_siglist but do not declare it. */
+#if !defined(HAVE_STRSIGNAL) && !defined (SYS_SIGLIST_DECLARED) && !defined (HAVE_SYS_SIGLIST)
 extern const char *sys_siglist[];
 #endif
 
